#include <iostream>
#include "myheader.h"
#include <GL/glui.h>

void potential();
void bookkeep();
void pot_initialize_all();
void inverse(double mat[][3], double imat[][3]);
void rigid_shift(float z, float dx, float dy, float dz);
void rigid_shift_cfg(float z, float dx, float dy, float dz);

void rigid_shift_xy(float z, float dx, float dy, float dz, int ix, int iy)
{
  for (int i=1; i<=ix; i++) {
    for (int j=1; j<=iy; j++) {
      rigid_shift(z,dx,0,0);
    }
    for (int j=1; j<=iy; j++) {
      rigid_shift_cfg(z,-dx,0,0);
    }
    rigid_shift_cfg(z,0,dy,0);
    fprintf(miscfile, "\n"); fflush(miscfile);
  }
  for (int i=1; i<=ix; i++) {
    rigid_shift_cfg(z,0,-dy,0);
  }

  pot_initialize_all();
  bookkeep();
  potential();
  cellx=sqrt(cell.hmat[0][0]*cell.hmat[0][0]+cell.hmat[1][0]*cell.hmat[1][0]+cell.hmat[2][0]*cell.hmat[2][0])/ang;
  celly=sqrt(cell.hmat[0][1]*cell.hmat[0][1]+cell.hmat[1][1]*cell.hmat[1][1]+cell.hmat[2][1]*cell.hmat[2][1])/ang;
  cellz=sqrt(cell.hmat[0][2]*cell.hmat[0][2]+cell.hmat[1][2]*cell.hmat[1][2]+cell.hmat[2][2]*cell.hmat[2][2])/ang;
  cell1x=cell.hmat[0][0]/ang;cell1y=cell.hmat[1][0]/ang;cell1z=cell.hmat[2][0]/ang;
  cell2x=cell.hmat[0][1]/ang;cell2y=cell.hmat[1][1]/ang;cell2z=cell.hmat[2][1]/ang;
  cell3x=cell.hmat[0][2]/ang;cell3y=cell.hmat[1][2]/ang;cell3z=cell.hmat[2][2]/ang;
  f_max=atom.Fmax()/ev*ang;
  epotatom=atom.epotsum/ev/atom.natom;
}

void rigid_shift(float z, float dx, float dy, float dz)
{
  rigid_shift_cfg(z, dx, dy, dz);
  /*
  double qz;
  cell.hmat[0][2] += (double)dx*ang;
  cell.hmat[1][2] += (double)dy*ang;
  cell.hmat[2][2] += (double)dz*ang;
  inverse(cell.hmat,cell.hinmat);
  
  for (int i=1; i<=atom.natom; i++) {
    qz = cell.hinmat[2][0]*atom.rx[i]
      +  cell.hinmat[2][1]*atom.ry[i]
      +  cell.hinmat[2][2]*atom.rz[i];
    if (qz > z) {
      atom.rx[i] += (double)dx*ang;
      atom.ry[i] += (double)dy*ang;
      atom.rz[i] += (double)dz*ang;
    }
  }
  */

  pot_initialize_all();
  bookkeep();
  potential();
  cellx=sqrt(cell.hmat[0][0]*cell.hmat[0][0]+cell.hmat[1][0]*cell.hmat[1][0]+cell.hmat[2][0]*cell.hmat[2][0])/ang;
  celly=sqrt(cell.hmat[0][1]*cell.hmat[0][1]+cell.hmat[1][1]*cell.hmat[1][1]+cell.hmat[2][1]*cell.hmat[2][1])/ang;
  cellz=sqrt(cell.hmat[0][2]*cell.hmat[0][2]+cell.hmat[1][2]*cell.hmat[1][2]+cell.hmat[2][2]*cell.hmat[2][2])/ang;
  cell1x=cell.hmat[0][0]/ang;cell1y=cell.hmat[1][0]/ang;cell1z=cell.hmat[2][0]/ang;
  cell2x=cell.hmat[0][1]/ang;cell2y=cell.hmat[1][1]/ang;cell2z=cell.hmat[2][1]/ang;
  cell3x=cell.hmat[0][2]/ang;cell3y=cell.hmat[1][2]/ang;cell3z=cell.hmat[2][2]/ang;
  f_max=atom.Fmax()/ev*ang;
  epotatom=atom.epotsum/ev/atom.natom;
  //printf("%f %f %20.10e\n", cell.hmat[0][2]/ang, cell.hmat[1][2]/ang, epotatom);
  fprintf(miscfile, "%f %f %20.10e\n",
	  cell.hmat[0][2]/ang, cell.hmat[1][2]/ang, epotatom);
  fflush(miscfile);
}

void rigid_shift_cfg(float z, float dx, float dy, float dz)
{
  double qz;
  cell.hmat[0][2] += (double)dx*ang;
  cell.hmat[1][2] += (double)dy*ang;
  cell.hmat[2][2] += (double)dz*ang;
  inverse(cell.hmat,cell.hinmat);
  
  for (int i=1; i<=atom.natom; i++) {
    qz = cell.hinmat[2][0]*atom.rx[i]
      +  cell.hinmat[2][1]*atom.ry[i]
      +  cell.hinmat[2][2]*atom.rz[i];
    if (qz > z) {
      atom.rx[i] += (double)dx*ang;
      atom.ry[i] += (double)dy*ang;
      atom.rz[i] += (double)dz*ang;
    }
  }
}
